/*
  header file of the program
*/

// *********************************************
namespace
{
//lines befor and after referenced
enum { minus_area=3 };
enum {  plus_area=3 };

//max lenght of line of text file
enum { MAX_LEN=2048 };

//add to sss
const char  comment_prefix[]="#; ";
const char  tpl_line_sign[]= "#;   [ %05u ] (\"%s\")\n";
const char  tpl_not_in_order_line_sign[]="#; <<[ %05u ] (\"%s\")\n";

//print help message
void    usage()
{
const char  prog_name[]="ss2sss";

    printf("Usage: %s <file.ss>\n<file.sss> will be generated\n",
           prog_name);
    exit(0);
}

//file extentions
const char  in_ext1[]=".s";
const char  in_ext2[]=".ss";
const char  out_ext[]=".sss";

//error messages
const char  tpl_bad_format[]=       "%03u: '%s': invalid format: %s: \"%s\"\n";
const char  tpl_no_file_found[]=    "%03u: '%s': file number %u: file name \"%s\": no file found: \"%s\"\n";
const char  tpl_no_file_assigned[]= "%03u: '%s': file number %u is not assigned to any file: \"%s\"\n";
const char  tpl_no_file_line[]=     "file name \"%s\": has no line number %u\n";

// *******************
//signs
const char  file_sign[]=".file";
const char  loc_sign[]= ".loc";
const char  reserved_file[]="<built-in>";

// *******************
//lists of reffered lines
list<Tfile>     files;
uint            files_size=0;

list<Tline>     lines;
uint            lines_size=0;

// ************************************************************
//find file by src_file_number
list<Tfile>::iterator   find_file(const uint src_file_number)
{
list<Tfile>::iterator   it( files.begin() );

    //fprintf(stderr,"* files_size %u\n",files_size);

    for(uint i=files_size; i; --i, ++it)
     {
      if(it->file_number == src_file_number )
       {
        if(!it->is_reserved_file)return it;

        //fprintf(stderr,"* reserved %u\n",src_file_number);
        return files.end();
       }
     }
    //fprintf(stderr,"* not found %u\n",src_file_number);
    return files.end();
}

// *******************
//namespace
}

// ************************************************************
//
uint        Tfile::find_line_pos(const uint src_line)
{
    if( src_line < first_src_line )throw "find_line_pos: \"first_src_line\" overflow";
    if( line_pos.empty() )throw "find_line_pos: \"line_pos\" is empty";
    //if( (src_line-first_src_line) > line_pos_size )throw "find_line_pos: \"line_pos_size\" internal error";

    #ifdef MY_DBG7
    fprintf(stderr,"* 'line_pos' line_pos_size %u: first_src_lines %u: src_line %u\n", line_pos_size, first_src_line, src_line);
    #endif

    const uint last_line=(line_pos_size-1+first_src_line);

    //?last stored pos less than src_line
    if( last_line < src_line )
     {
      list<uint>::iterator    it( line_pos.end() );
      --it;
      if( fseek(fi,*it,SEEK_SET) )throw "find_line_pos: fseek error";

      #ifdef MY_DBG7
      fprintf(stderr,"* 'line_pos' add from pos %d\n",*it);
      #endif

      for(uint i=src_line-last_line; i; --i, ++it)
       {
        #ifdef MY_DBG7
        fprintf(stderr,"= 'line_pos' current pos %d\n",*it);
        #endif

        getln(0,0,fi);
        if(feof(fi))return EOF;

        line_pos.push_back( ftell(fi) );
        ++line_pos_size;
       }

      #ifdef MY_DBG7
      fprintf(stderr,"= 'line_pos' pos to return %d\n",*it);
      #endif
      return *it;
     }

    //[src_line-first_src_line]
    {
    list<uint>::iterator    it(line_pos.begin());

    //if(src_line>first_src_line)
    for(uint i=src_line-first_src_line; i; --i)
     {
      #ifdef MY_DBG7
      fprintf(stderr,"$ 'line_pos' current pos %d\n",*it);
      #endif
      ++it;
     }

    #ifdef MY_DBG7
    fprintf(stderr,"$ 'line_pos' pos to return %d\n",*it);
    #endif
    return *it;
    }
}

// ************************************************************
