/*

    2007, (C) Polyanin M.A. 
    See "readme.txt" for description of the program.

*/

// *********************************************
// *********************************************
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

//some user defined classes
//probably you no need to edit the file
#include "s2s_lib.h"
using Ns::uint;
using Ns::Terr;
using Ns::Terr_zptr;
using Ns::Tarray_holder;
using Ns::Tauto_array;

//some user defined classes
//probably you no need to edit the file
namespace{
#include "s2s_lib.cpp"
}

#include <list>
#include <vector>
using std::list;
using std::vector;

//#define MY_DBG
//#define MY_DBG1
//#define MY_DBG2
//#define MY_DBG3
//#define MY_DBG4
//#define MY_DBG5
//#define MY_DBG6
//#define MY_DBG7

//header file of the program
#include "s2s.h"
using Ns::Tfile;
using Ns::Tline;

//header file of the program
#include "s2s.cpp"

// *********************************************
// *********************************************
int     main(int argc, char *argv[])
{
//char    tmpfile[L_tmpnam];
FILE    *fi=0;
FILE    *fo=0;

try{
    if(argc!=2)usage();

char                   *in_fname=argv[1];
Tarray_holder<char>    out_fname;

// ******************************************************
//get ss file name
{
char    *ext=0;
uint    ext_offs=0;

    if( (ext=strrchr(in_fname,'.')) )
     {
      if( !stricmp(ext,out_ext) )throw "extention of input file is equal to output";
      ext_offs=static_cast<uint>(ext-in_fname);
     }
    fi=fopen(in_fname,"rb"); if(!fi)throw in_fname;

    #ifdef MY_DBG
    fprintf(stderr,"opened 'fi': %s\n",in_file);
    #endif

const uint  in_fname_len=strlen(in_fname);
    //make sss file name
    out_fname= new char[in_fname_len+strlen(out_ext)+1];
    strcpy( out_fname(0), in_fname );

    ext= out_fname(0)+ (ext_offs? ext_offs: in_fname_len);
    strcpy( ext, out_ext );
    fo=fopen(out_fname(0),"wt"); if(!fo)throw Terr( out_fname(0) );

    #ifdef MY_DBG
    fprintf(stderr,"opened 'fo':%s\n",out_file(0));
    #endif
}

char    buf[MAX_LEN+1];
uint    asm_lines=0;

uint    last_src_line=0;

// ******************************************************
    //create src tree
    for(;;)
     {
      if(feof(fi))break;

      //next line
      getln(buf,MAX_LEN,fi);
      ++asm_lines;
      if(!buf[0])continue;

      ////find signs

      //skip spaces
      char *st=buf;
      while( isspace(*st) )++st;
      if(!*st)continue;

      // *******************
      //file_sign;//[]=".file";
      if( !strncmp(st,file_sign,strlen(file_sign)) )
       {
        st+=strlen(file_sign);

        //skip spaces
        while( isspace(*st) )++st;
        if(!*st)continue;

        //?other format
        if(*st=='"')continue;

        //found number, file
        #ifdef MY_DBG4
        fprintf(stderr,"found file number, file name: %s\n",st);
        #endif

        //?bad format
        char *f_st=0;
        if(! (f_st=strchr(st,'"')) )
         {
          fprintf(stderr,tpl_bad_format,asm_lines,file_sign,"start of file name",buf);
          continue;
         }
        f_st[0]=0;

        //
        char *f_end=0;
        if(! (f_end=strchr(f_st+1,'"')) )
         {
          f_st[0]='"';
          fprintf(stderr,tpl_bad_format,asm_lines,file_sign,"end of file name",buf);
          continue;
         }
        f_end[0]=0;

        //ok format

        //get file number
        uint number=0;
        if( (sscanf(st,"%u",&number) != 1) || (!number) )
         {
          f_st[0]='"';
          f_end[0]='"';
          fprintf(stderr,tpl_bad_format,asm_lines,file_sign,"get file number",buf);
          continue;
         }

        //test file number is dublicated
        if(files_size && (find_file(number) != files.end()) )
         {
          f_st[0]='"';
          f_end[0]='"';
          fprintf(stderr,tpl_bad_format,asm_lines,file_sign,"dublicated file number",buf);
          continue;
         }

        char is_reserved_file=1;
        FILE *ft=0;

        //?!is_reserved_file
        if( strcmp(f_st+1,reserved_file) )
        {
         is_reserved_file=0;

         ft=fopen(f_st+1,"rb");
         if(!ft)
          {
           Tarray_holder<char>  fname( new char[strlen(f_st+1)]+1 );
           strcpy(fname(0),f_st+1);

           f_st[0]='"';
           f_end[0]='"';
           fprintf(stderr,tpl_no_file_found,asm_lines,file_sign,number,fname(0),buf);

           continue;
          }
         //fclose(ft);
        }

        //store record about source file
        Tfile   tmp(number,is_reserved_file,ft);

        tmp.file_name=new char[strlen(f_st+1)+1];
        strcpy(tmp.file_name(0),f_st+1);

        #ifdef MY_DBG1
        fprintf(stderr,"%02u: %s: %u: %s file: %s\n",
                        asm_lines,file_sign,
                        tmp.file_number,
                        (tmp.is_reserved_file?"reserved":"ordinary"),
                        f_st+1
                );
        #endif

        files.push_back(tmp);
        ++files_size;

        //
        continue;
       }

      // *******************
      //loc_sign;//[]= ".loc";
      if( !strncmp(st,loc_sign,strlen(loc_sign)) )
       {
        st+=strlen(loc_sign);

        //found line number, file number
        #ifdef MY_DBG4
        fprintf(stderr,"found line number, file number: %s\n",st);
        #endif

        Tline   tmp(asm_lines);

        if( sscanf(st,"%u %u",
                      &tmp.src_file_number,
                      &tmp.src_line_number)!=2 )
         {
          fprintf(stderr,tpl_bad_format,asm_lines,loc_sign,"get file/line number",buf);
          continue;
         }

        #ifdef MY_DBG5
        fprintf(stderr,"* %u: %u %u: %s\n",asm_lines,tmp.src_file_number,tmp.src_line_number,buf);
        #endif

        //
        if(!tmp.src_line_number)
         {
          fprintf(stderr,tpl_bad_format,asm_lines,loc_sign,"zero line number",buf);
          continue;
         }

        //find file record
        std::list<Tfile>::iterator      it( find_file(tmp.src_file_number) );

        if( it == files.end() )
         {
          fprintf(stderr,tpl_no_file_assigned,asm_lines,loc_sign,tmp.src_file_number,buf);

          continue;
         }

        if( !it->first_src_line )
         {
          it->first_src_line=tmp.src_line_number;
         }
        else
         {
          if( it->first_src_line > tmp.src_line_number )it->first_src_line=tmp.src_line_number;
         }

        //?is_src_not_in_order
        if( last_src_line >= tmp.src_line_number )tmp.is_src_not_in_order=1;
        else last_src_line = tmp.src_line_number;

        #ifdef MY_DBG2
        fprintf(stderr,"%02u: %s: file %u: line %u: %s\n",
                       asm_lines, loc_sign, tmp.src_file_number, tmp.src_line_number,
                       (tmp.is_src_not_in_order? "unsorted": "ok")
                       );
        #endif

        lines.push_back(tmp);
        ++lines_size;

        //
        continue;
       }
     }

    #ifdef MY_DBG
    fprintf(stderr,"press key to second pass\n");
    getchar();
    #endif

// ******************************************************
    //next pass
    if( fseek(fi,0,SEEK_SET) )throw "fseek input file";

    //find first used line for each src file
    #ifdef MY_DBG
    fprintf(stderr,"find first used line for each src file\n");
    #endif
{
list<Tfile>::iterator      it( files.begin() );

    #ifdef MY_DBG
    fprintf(stderr,"files_size: %u\n",files_size);
    #endif

    for(uint i=files_size; i; --i, ++it)
     {
      //reserved
      if(it->is_reserved_file)continue;
      //not used
      if(!it->first_src_line)continue;

      #ifdef MY_DBG3
      fprintf(stderr,"+ src it->first_src_line: %u\n",it->first_src_line);
      #endif
      if(!it->fi)throw "zptr it->fi";

      //used
      it->line_pos.push_back(0);
      ++it->line_pos_size;

      //const uint from= (it->first_src_line >= minus_area)?
      //                      ( it->first_src_line - minus_area ):
      //                      0;
      it->first_src_line= (it->first_src_line >= minus_area)?
                            ( it->first_src_line - minus_area ):
                            0;

      //if(!from)continue;
      #ifdef MY_DBG3
      fprintf(stderr,"+ it->first_src_line: %u\n",it->first_src_line);
      #endif

      if(!it->first_src_line)continue;
      list<uint>::iterator      line_pos_it( it->line_pos.begin() );

      //for(uint line=from-1; line; --line)
      for(uint line=it->first_src_line-1; line; --line)
       {
        if(feof(it->fi))
         {
          fprintf(stderr,tpl_no_file_line,it->file_name(0),it->first_src_line);
          break;
         }
        getln(0,0,it->fi);

        *line_pos_it=ftell(it->fi);
        //it->line_pos.push_back(ftell(it->fi));
        //++it->line_pos_size;
       }

      #ifdef MY_DBG3
      fprintf(stderr,"+ line_pos_it: %u\n",*line_pos_it);
      #endif
     }
}

    //create output
    #ifdef MY_DBG
    fprintf(stderr,"create output\n");
    #endif

{
std::list<Tline>::iterator      lines_it( lines.begin() );
std::list<Tline>::iterator      lines_end( lines.end() );

    for(uint asm_line=0;;)
     {
      if(feof(fi))break;

      //next line
      getln(buf,MAX_LEN,fi);
      ++asm_line;

      fprintf(fo,"%s\n",buf);
      if(!buf[0])continue;

      //include source lines
      if( lines_it->asm_line_number == asm_line )
       {
        std::list<Tline>::iterator      lines_st(lines_it++);
        //lines_it  point to next independed from unsorted state
        //lines_tmp point to cuerrent

        list<Tfile>::iterator       file_it(find_file(lines_st->src_file_number));

        if(lines_st->is_src_not_in_order)
         {
          //src "not_in_order" start sign
          fprintf(fo,"%s\n",comment_prefix);
          fprintf(fo,tpl_not_in_order_line_sign,lines_st->src_line_number,file_it->file_name(0),buf);
          fprintf(fo,"%s\n",comment_prefix);
          //continue;
         }

//const char  comment_prefix[]="#; ";
//const char  tpl_line_sign[]="#; [ %05u ] (\"%s\")\n";
//const char  tpl_not_in_order_line_sign[]="#; <<[ %05u ] (\"%s\")\n";

        else
         {
          //src start sign
          fprintf(fo,"%s\n",comment_prefix);
          fprintf(fo,tpl_line_sign,lines_st->src_line_number,file_it->file_name(0),buf);
          fprintf(fo,"%s\n",comment_prefix);
         }

        //src lines to print
        const uint from= (lines_st->src_line_number >= minus_area)?
                            ( lines_st->src_line_number - minus_area ):
                            0;

        //file_it->first_src_line+file_it->line_pos_size
        const uint to  = lines_st->src_line_number + plus_area;

        #ifdef MY_DBG6
        fprintf(stderr,"* src %u: from %u: to %u\n",lines_st->src_line_number, from, to);
        #endif

        //file_it->find_line_pos(lines_st->src_line_number);
        for(;;)
        {
        FILE *ft=file_it->fi;

        const uint pos=file_it->find_line_pos(from);
        if( int(pos)==EOF )break;

        #ifdef MY_DBG6
        fprintf(stderr,"* src %u: pos %d\n",lines_st->src_line_number, pos);
        #endif

        fseek( ft, pos, SEEK_SET );

        for( uint line=from; line <= to; ++line )
         {
          getln(buf,MAX_LEN,ft);

          if(line==lines_st->src_line_number)
           fprintf(fo,
                    "%s===\n"
                    "%s %d; %s\n"
                    "%s===\n",
                    comment_prefix,
                    comment_prefix,
                    (line-lines_st->src_line_number),
                    buf,
                    comment_prefix
                  );
          else
           fprintf(fo,
                    "%s%+d; %s\n",
                    comment_prefix,
                    (line-lines_st->src_line_number),
                    buf
                  );

          if(feof(ft))break;
         }

         break;
         }

       fprintf(fo,"%s\n",comment_prefix);
       //endif include source lines
       }

     //endfor create output
     }
}

}
// ******************
catch(const char* err)
{
    fprintf(stderr,"error: %s\n",err);
}
// ******************
catch(Terr& err)
{
    fprintf(stderr,"error: %s\n",err.what());
}
// ******************
catch(...)
{
    fprintf(stderr,"error: %s\n","unknown");
}

// ******************
    //if(fi){ fclose(fi); }
    //if(fo){ fclose(fo); }

// ******************
// ******************
}

